Loading...
Searching...
No Matches
casacore::MVEarthMagnetic Class Reference
casa package (libcasa_casa) » Quanta_module » Quanta_module_internal_classes

More...

`#include <MVEarthMagnetic.h>`

## Public Member Functions

| MVEarthMagnetic ()
| Default constructor generates a (0,0,0) EarthMagnetic.
| MVEarthMagnetic (const MVPosition &other)
| Creates from an MVPosition.
| MVEarthMagnetic (Double in0, Double in1, Double in2)
| Creates a specified vector.
| MVEarthMagnetic (Double in0)
| Creates a vector with specified length towards pole.
| MVEarthMagnetic (const Quantity &l)
| MVEarthMagnetic (const Quantity &l, Double angle0, Double angle1)
| Creates the EarthMagnetic from specified (azimuth,elevation) angles and length.
| MVEarthMagnetic (const Quantity &l, const Quantity &angle0, const Quantity &angle1)
| Creates the EarthMagnetic from specified angles and length.
| MVEarthMagnetic (const Quantum< Vector< Double > > &angle)
| If not enough angles: pole assumed (if none), or elevation =0 (if 1).
| MVEarthMagnetic (const Quantity &l, const Quantum< Vector< Double > > &angle)
| MVEarthMagnetic (const Vector< Double > &other)
| Create from specified length and/or angles and/or EarthMagnetic.
| MVEarthMagnetic (const Vector< Quantity > &other)
Double | operator* (const MVEarthMagnetic &other) const
| Multiplication defined as in-product.
Bool | operator== (const MVEarthMagnetic &other) const
| Equality comparisons.
Bool | operator!= (const MVEarthMagnetic &other) const
Bool | near (const MVEarthMagnetic &other, Double tol=1e-13) const
Bool | near (const MVEarthMagnetic &other, Quantity tol) const
Bool | nearAbs (const MVEarthMagnetic &other, Double tol=1e-13) const
MVEarthMagnetic | operator- () const
| Addition and subtraction.
MVEarthMagnetic & | operator+= (const MVEarthMagnetic &right)
MVEarthMagnetic | operator+ (const MVEarthMagnetic &right) const
MVEarthMagnetic & | operator-= (const MVEarthMagnetic &right)
MVEarthMagnetic | operator- (const MVEarthMagnetic &right) const
virtual void | adjust ()
| Normalise direction aspects by adjusting the length to 1.
virtual void | adjust (Double &res)
| Adjustment with returned factor.
virtual void | readjust (Double res)
| Re-adjust using factor given.
virtual Double | radius ()
| Get modulus of EarthMagnetic.
Vector< Double > | get () const
| Generate a 3-vector of coordinates (length(T), angles(rad)).
const Vector< Double > & | getValue () const
| Generate a 3-vector of x,y,z in tesla.
Quantum< Vector< Double > > | getAngle () const
| Generate angle 2-vector (in rad).
Quantum< Vector< Double > > | getAngle (const Unit &unit) const
| and with specified units
Quantity | getLength () const
| Generate the length.
Quantity | getLength (const Unit &unit) const
| and generate it with the specified units
Double | earthMagneticAngle (const MVEarthMagnetic &other) const
| Get the EarthMagnetic angle between the directions.
Quantity | earthMagneticAngle (const MVEarthMagnetic &other, const Unit &unit) const
Double | separation (const MVEarthMagnetic &other) const
| Get the angular separation between two directions.
Quantity | separation (const MVEarthMagnetic &other, const Unit &unit) const
MVEarthMagnetic | crossProduct (const MVEarthMagnetic &other) const
| Produce the cross product.
virtual void | print (ostream &os) const
| Print data.
virtual MeasValue * | clone () const
| Clone.
virtual Vector< Double > | getVector () const
| Get the value in internal units.
virtual void | putVector (const Vector< Double > &in)
| Set the value from internal units (set 0 for empty vector).
virtual Vector< Quantum< Double > > | getRecordValue () const
| Get the internal value as a Vector<Quantity>.
virtual Bool | putValue (const Vector< Quantum< Double > > &in)
| Set the internal value if correct values and dimensions.
Public Member Functions inherited from casacore::MVPosition
| MVPosition ()
| Default constructor generates a (0,0,0) position.
| MVPosition (const MVPosition &other)
| Copy constructor.
| MVPosition (Double in0, Double in1, Double in2)
| Creates a specified vector.
| MVPosition (Double in0)
| Creates a vector with specified length towards pole.
| MVPosition (const Quantity &l)
| MVPosition (const Quantity &l, Double angle0, Double angle1)
| Creates the position from specified (azimuth,elevation) angles and length.
| MVPosition (const Quantity &l, const Quantity &angle0, const Quantity &angle1)
| Creates the position from specified angles and length.
| MVPosition (const Quantum< Vector< Double > > &angle)
| If not enough angles: pole assumed (if none), or elevation =0 (if 1).
| MVPosition (const Quantity &l, const Quantum< Vector< Double > > &angle)
| MVPosition (const Vector< Double > &other)
| Create from specified length and/or angles and/or position.
| MVPosition (const Vector< Quantity > &other)
MVPosition & | operator= (const MVPosition &other)
| Copy assignment.
virtual | ~MVPosition ()
| Destructor.
Double | operator* (const MVPosition &other) const
| Multiplication defined as in-product.
Bool | operator== (const MVPosition &other) const
| Equality comparisons.
Bool | operator!= (const MVPosition &other) const
Bool | near (const MVPosition &other, Double tol=1e-13) const
Bool | near (const MVPosition &other, Quantity tol) const
Bool | nearAbs (const MVPosition &other, Double tol=1e-13) const
MVPosition | operator- () const
| Addition and subtraction.
MVPosition & | operator+= (const MVPosition &right)
MVPosition | operator+ (const MVPosition &right) const
MVPosition & | operator-= (const MVPosition &right)
MVPosition | operator- (const MVPosition &right) const
MVPosition & | operator*= (const RotMatrix &right)
| Multiplication with rotation matrix (see also global functions).
MVPosition & | operator*= (Double right)
| Multiplication with constant.
Double & | operator() (uInt which)
| Obtain an element.
const Double & | operator() (uInt which) const
Vector< Double > | get () const
| Generate a 3-vector of coordinates (length(m), angles(rad)).
const Vector< Double > & | getValue () const
| Generate a 3-vector of x,y,z in m.
Quantum< Vector< Double > > | getAngle () const
| Generate angle 2-vector (in rad).
Quantum< Vector< Double > > | getAngle (const Unit &unit) const
| and with specified units
Double | getLong () const
| Get the longitudinal angle (in radians).
Quantity | getLong (const Unit &unit) const
| and with specified units
Double | getLat () const
| Get the latitude angle (rad).
Quantity | getLat (const Unit &unit) const
| and with specified units
Quantity | getLength () const
| Generate the length.
Quantity | getLength (const Unit &unit) const
| and generate it with the specified units
Double | positionAngle (const MVPosition &other) const
| Get the position angle between the directions.
Quantity | positionAngle (const MVPosition &other, const Unit &unit) const
Double | separation (const MVPosition &other) const
| Get the angular separation between two directions.
Quantity | separation (const MVPosition &other, const Unit &unit) const
MVPosition | crossProduct (const MVPosition &other) const
| Produce the cross product.
virtual Vector< Quantum< Double > > | getXRecordValue () const
virtual Vector< Quantum< Double > > | getTMRecordValue () const
Public Member Functions inherited from casacore::MeasValue
void | dummy_constr () const
| Each derived class should have at least the following constructors:
virtual | ~MeasValue ()
| Destructor.
void | dummy_operator () const
| The following operators should be present at least.

## Static Public Member Functions

static void | assure (const MeasValue &in)
| Tell me your type.
Static Public Member Functions inherited from casacore::MVPosition
static void | assure (const MeasValue &in)
| Tell me your type.

## Additional Inherited Members

Static Public Attributes inherited from casacore::MVPosition
static const Double | loLimit
| Internal limts codes for negative height.
static const Double | hiLimit
Protected Member Functions inherited from casacore::MVPosition
Double | getLat (Double ln) const
| Get the latitude assuming length is given.
Protected Attributes inherited from casacore::MVPosition
Vector< Double > | xyz
| Position vector (in m).

## Detailed Description

A 3D Earth magnetic field vector

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- MeasValue
- Vector
- Quantum

### Etymology

From Measure, Value and Earth Magnetic field

### Synopsis

A MVEarthMagnetic is a 3-vector of the Earth's magnetic flux density in a rectangular frame with the z-axis to astronomical North pole, and x-axis towards longitude zero, in internal Units of nano tesla (== 0.00001 G).
It can be constructed with:

- MVEarthMagnetic() creates (0,0,0)
- MVEarthMagnetic(MVEarthMagnetic) creates a copy
- MVEarthMagnetic(MVPosition) creates (x,y,z) from the given position
- MVEarthMagnetic(Double, Double, Double) creates (x,y,z) with specified values in tesla
- MVEarthMagnetic(Quantity length,Double, Double) creates an MVEarthMagnetic assuming that the two values are (in radians) angle along 'equator' and towards 'pole'.
- MVEarthMagnetic(Quantity length, Quantity, Quantity) creates an MVEarthMagnetic assuming angles as in previous, or (x,y,z) fields
- MVEarthMagnetic(Quantity, Quantum<Vector<Double> >) creates a MVEarthMagnetic from angle vector, using first two angles, and assuming second as zero if not present, and pole if length 0.
- MVEarthMagnetic(Quantum<Vector<Double> > creates from angles or fields, depending on the units in the quantum vector. In the angle case, the data derived can be scaled with the readjust() function. If the unit of the quantum vector is magnetic flux density, magnetic field components are assumed.
- MVEarthMagnetic(Vector<Double> creates from angles (less than or equal to two elements) or x,y,z (3 elements).
- MVEarthMagnetic(Vector<Quantity> creates from length+angles, angles, or x,y,z, depending on units.

A void adjust(Double) function normalises the vector to a length of 1; a get() returns as a Double 3-vector the length and angles of the EarthMagnetic vector; a getAngle() returns a Quantum 2-vector, (uInt) returns the indicated element, and getValue returns the vector.
EarthMagnetics can be added and subtracted.
The multiplication of two EarthMagnetics produces the in-product.

### Example

See MEarthMagnetic class.

### Motivation

To use in ionospheric effect calculations

### To Do

- nothing I know of

Definition at line 108 of file MVEarthMagnetic.h.

## Constructor & Destructor Documentation

## MVEarthMagnetic() [1/11]

casacore::MVEarthMagnetic::MVEarthMagnetic | ( |  | ) |

Default constructor generates a (0,0,0) EarthMagnetic.

Referenced by crossProduct(), earthMagneticAngle(), earthMagneticAngle(), near(), near(), nearAbs(), operator!=(), operator*(), operator+(), operator+=(), operator-(), operator-(), operator-=(), operator==(), separation(), and separation().

## MVEarthMagnetic() [2/11]

casacore::MVEarthMagnetic::MVEarthMagnetic | ( | const MVPosition & | other | ) |

Creates from an MVPosition.

References casacore::MVPosition::MVPosition().

## MVEarthMagnetic() [3/11]

casacore::MVEarthMagnetic::MVEarthMagnetic | ( | Double | in0,
|  | Double | in1,
|  | Double | in2 )

Creates a specified vector.

## MVEarthMagnetic() [4/11]

casacore::MVEarthMagnetic::MVEarthMagnetic | ( | Double | in0 | ) |

explicit

Creates a vector with specified length towards pole.

## MVEarthMagnetic() [5/11]

casacore::MVEarthMagnetic::MVEarthMagnetic | ( | const Quantity & | l | ) |

## MVEarthMagnetic() [6/11]

casacore::MVEarthMagnetic::MVEarthMagnetic | ( | const Quantity & | l,
|  | Double | angle0,
|  | Double | angle1 )

Creates the EarthMagnetic from specified (azimuth,elevation) angles and length.

## MVEarthMagnetic() [7/11]

casacore::MVEarthMagnetic::MVEarthMagnetic | ( | const Quantity & | l,
|  | const Quantity & | angle0,
|  | const Quantity & | angle1 )

Creates the EarthMagnetic from specified angles and length.

or EarthMagnetics

### Thrown Exceptions

- AipsError if quantities not in angle format

## MVEarthMagnetic() [8/11]

casacore::MVEarthMagnetic::MVEarthMagnetic | ( | const Quantum< Vector< Double > > & | angle | ) |

If not enough angles: pole assumed (if none), or elevation =0 (if 1).

## MVEarthMagnetic() [9/11]

casacore::MVEarthMagnetic::MVEarthMagnetic | ( | const Quantity & | l,
|  | const Quantum< Vector< Double > > & | angle )

## MVEarthMagnetic() [10/11]

casacore::MVEarthMagnetic::MVEarthMagnetic | ( | const Vector< Double > & | other | ) |

Create from specified length and/or angles and/or EarthMagnetic.

## MVEarthMagnetic() [11/11]

casacore::MVEarthMagnetic::MVEarthMagnetic | ( | const Vector< Quantity > & | other | ) |

## Member Function Documentation

## adjust() [1/2]

virtual void casacore::MVEarthMagnetic::adjust | ( |  | ) |

virtual

Normalise direction aspects by adjusting the length to 1.

Reimplemented from casacore::MVPosition.

## adjust() [2/2]

virtual void casacore::MVEarthMagnetic::adjust | ( | Double & | res | ) |

virtual

Adjustment with returned factor.

Reimplemented from casacore::MVPosition.

## assure()

void casacore::MVEarthMagnetic::assure | ( | const MeasValue & | in | ) |

static

Tell me your type.

## clone()

virtual MeasValue * casacore::MVEarthMagnetic::clone | ( |  | ) | const

virtual

Clone.

Reimplemented from casacore::MVPosition.

## crossProduct()

MVEarthMagnetic casacore::MVEarthMagnetic::crossProduct | ( | const MVEarthMagnetic & | other | ) | const

Produce the cross product.

References MVEarthMagnetic().

## earthMagneticAngle() [1/2]

Double casacore::MVEarthMagnetic::earthMagneticAngle | ( | const MVEarthMagnetic & | other | ) | const

Get the EarthMagnetic angle between the directions.

I.e. the angle between the direction from one to the pole, and from one to the other.

References MVEarthMagnetic().

## earthMagneticAngle() [2/2]

Quantity casacore::MVEarthMagnetic::earthMagneticAngle | ( | const MVEarthMagnetic & | other,
|  | const Unit & | unit ) const

References MVEarthMagnetic().

## get()

Vector< Double > casacore::MVEarthMagnetic::get | ( |  | ) | const

Generate a 3-vector of coordinates (length(T), angles(rad)).

## getAngle() [1/2]

Quantum< Vector< Double > > casacore::MVEarthMagnetic::getAngle | ( |  | ) | const

Generate angle 2-vector (in rad).

## getAngle() [2/2]

Quantum< Vector< Double > > casacore::MVEarthMagnetic::getAngle | ( | const Unit & | unit | ) | const

and with specified units

## getLength() [1/2]

Quantity casacore::MVEarthMagnetic::getLength | ( |  | ) | const

Generate the length.

## getLength() [2/2]

Quantity casacore::MVEarthMagnetic::getLength | ( | const Unit & | unit | ) | const

and generate it with the specified units

## getRecordValue()

virtual Vector< Quantum< Double > > casacore::MVEarthMagnetic::getRecordValue | ( |  | ) | const

virtual

Get the internal value as a Vector<Quantity>.

Usable in records. The getXRecordValue() gets additional information for records. Note that the Vectors could be empty.

Reimplemented from casacore::MVPosition.

## getValue()

const Vector< Double > & casacore::MVEarthMagnetic::getValue | ( |  | ) | const

Generate a 3-vector of x,y,z in tesla.

## getVector()

virtual Vector< Double > casacore::MVEarthMagnetic::getVector | ( |  | ) | const

virtual

Get the value in internal units.

Reimplemented from casacore::MVPosition.

## near() [1/2]

Bool casacore::MVEarthMagnetic::near | ( | const MVEarthMagnetic & | other,
|  | Double | tol = 1e-13 ) const

References MVEarthMagnetic().

## near() [2/2]

Bool casacore::MVEarthMagnetic::near | ( | const MVEarthMagnetic & | other,
|  | Quantity | tol ) const

References MVEarthMagnetic().

## nearAbs()

Bool casacore::MVEarthMagnetic::nearAbs | ( | const MVEarthMagnetic & | other,
|  | Double | tol = 1e-13 ) const

References MVEarthMagnetic().

## operator!=()

Bool casacore::MVEarthMagnetic::operator!= | ( | const MVEarthMagnetic & | other | ) | const

References MVEarthMagnetic().

## operator*()

Double casacore::MVEarthMagnetic::operator* | ( | const MVEarthMagnetic & | other | ) | const

Multiplication defined as in-product.

References MVEarthMagnetic().

## operator+()

MVEarthMagnetic casacore::MVEarthMagnetic::operator+ | ( | const MVEarthMagnetic & | right | ) | const

References MVEarthMagnetic().

## operator+=()

MVEarthMagnetic & casacore::MVEarthMagnetic::operator+= | ( | const MVEarthMagnetic & | right | ) |

References MVEarthMagnetic().

## operator-() [1/2]

MVEarthMagnetic casacore::MVEarthMagnetic::operator- | ( |  | ) | const

Addition and subtraction.

References MVEarthMagnetic().

## operator-() [2/2]

MVEarthMagnetic casacore::MVEarthMagnetic::operator- | ( | const MVEarthMagnetic & | right | ) | const

References MVEarthMagnetic().

## operator-=()

MVEarthMagnetic & casacore::MVEarthMagnetic::operator-= | ( | const MVEarthMagnetic & | right | ) |

References MVEarthMagnetic().

## operator==()

Bool casacore::MVEarthMagnetic::operator== | ( | const MVEarthMagnetic & | other | ) | const

Equality comparisons.

References MVEarthMagnetic().

## print()

virtual void casacore::MVEarthMagnetic::print | ( | ostream & | os | ) | const

virtual

Print data.

Reimplemented from casacore::MVPosition.

## putValue()

virtual Bool casacore::MVEarthMagnetic::putValue | ( | const Vector< Quantum< Double > > & | in | ) |

virtual

Set the internal value if correct values and dimensions.

Reimplemented from casacore::MVPosition.

## putVector()

virtual void casacore::MVEarthMagnetic::putVector | ( | const Vector< Double > & | in | ) |

virtual

Set the value from internal units (set 0 for empty vector).

Reimplemented from casacore::MVPosition.

## radius()

virtual Double casacore::MVEarthMagnetic::radius | ( |  | ) |

virtual

Get modulus of EarthMagnetic.

Reimplemented from casacore::MVPosition.

## readjust()

virtual void casacore::MVEarthMagnetic::readjust | ( | Double | res | ) |

virtual

Re-adjust using factor given.

Reimplemented from casacore::MVPosition.

## separation() [1/2]

Double casacore::MVEarthMagnetic::separation | ( | const MVEarthMagnetic & | other | ) | const

Get the angular separation between two directions.

References MVEarthMagnetic().

## separation() [2/2]

Quantity casacore::MVEarthMagnetic::separation | ( | const MVEarthMagnetic & | other,
|  | const Unit & | unit ) const

References MVEarthMagnetic().

The documentation for this class was generated from the following file:

- casa/Quanta/MVEarthMagnetic.h